const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const tenderPaymentTermService = require("./tenderPaymentTerm.service");
const redisClient = require('../../../../redisClient');

router.post("/create", authorize(), create);
router.post("/", authorize(), getAll);
router.post("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    tenderPaymentTermService
        .create(req.body)
        .then((result) => res.json(result))
        .catch(next);
}


function getAll(req, res, next) {
  tenderPaymentTermService
    .getAll(req.body)
    .then((result) => res.json(result))
    .catch(next);
}


async function option(req, res, next) {
    try {
        // Membuat cacheKey
        const cacheKey = `tenderpaymentterms-options`;

        // Mengecek apakah data sudah ada di Redis
        const cachedData = await redisClient.get(cacheKey);
        if (cachedData) {
            return res.json(JSON.parse(cachedData));
        }

        // Jika tidak ada, panggil tenderPaymentTermService.option()
        const result = await tenderPaymentTermService.option();

        // Simpan hasilnya ke Redis dengan expire time misalnya 60 detik
        await redisClient.setEx(cacheKey, 60, JSON.stringify(result));

        // Kembalikan response JSON dari hasil panggilan service
        return res.json(result);
    } catch (error) {
        return next(error);
    }
}

// function option(req, res, next) {
//     tenderPaymentTermService
//         .option()
//         .then((result) => res.json(result))
//         .catch(next);
// }

function count(req, res, next) {
    tenderPaymentTermService
        .count()
        .then((result) => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    tenderPaymentTermService
        .update(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    tenderPaymentTermService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    tenderPaymentTermService
        .delete(req.params.id)
        .then((result) => res.json(result))
        .catch(next);
}
